'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = deprecate;

var _scope;

function _load_scope() {
  return _scope = require('../../../scope');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../../bit-id');
}

var _constants;

function _load_constants() {
  return _constants = require('../../../constants');
}

var _hooks;

function _load_hooks() {
  return _hooks = _interopRequireDefault(require('../../../hooks'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var HooksManagerInstance = (_hooks || _load_hooks()).default.getInstance();

function deprecate(_ref, headers) {
  var path = _ref.path,
      ids = _ref.ids;

  var bitIds = (_bitId || _load_bitId()).BitIds.deserialize(ids);
  var args = { path, bitIds };
  HooksManagerInstance.triggerHook((_constants || _load_constants()).PRE_DEPRECATE_REMOTE, args, headers);
  return (0, (_scope || _load_scope()).loadScope)(path).then(function (scope) {
    return scope.deprecateMany(bitIds).then(function (res) {
      HooksManagerInstance.triggerHook((_constants || _load_constants()).POST_DEPRECATE_REMOTE, {
        deprecatedComponentsIds: res.bitIds,
        missingComponentsIds: res.missingComponents,
        scopePath: path,
        componentsIds: bitIds.serialize(),
        scopeName: scope.scopeJson.name
      }, headers);
      return res;
    });
  });
}